#ifndef _TREE_H
#define _TREE_H

#include "build.h"
#include <qstring.h>
#include <qfile.h>
#include <qdir.h>

class MyTree
{
 private:

  MyTree* ptr;
  MyTree *children[MAXCHILDREN];
  int numchildren;
  int terror;

  int CutIdString(QString* base, QString* result[]);
  bool CutFileData(QString buf, QString *t1[], int t2[]);
  bool RemoveLeaf(MyTree *p);
  bool WriteLeaf(MyTree *p, QFile *f);

 public:  
  QString* feature1[NUMFEATURE1];
  int feature2[NUMFEATURE2];
  MyTree* root;
  MyTree *parent;
    
  MyTree();
  ~MyTree();
  MyTree* Find(QString* id);
  MyTree* FindParent(QString* id);
  MyTree* findFeature1(MyTree *t, int which, QString *what);
  bool Tree2File(QString filename, QString home);
  bool File2Tree(QString filename, QString home);
  bool Add(QString* tab1[], int tab2[]);
  bool Remove(QString* id);
  bool Update(QString* tab1[], int tab2[]);
  QString* GetFeature1(int which);
  int GetFeature2(int which);
  bool SetFeature1(int which, QString* what);
  bool SetFeature1(int which, QString what);
  bool SetFeature2(int which, int what);
  bool IncChildren();
  bool DecChildren();
  MyTree* GetParent() { return parent; }
  MyTree* GetPtr() { return ptr; }
  MyTree* GetChildren(int which) { return children[which]; }
  int GetNumChildren() { return numchildren; }
  int GetNumAllChildren();
  bool FindFeature(MyTree *t, int where, QString name, int what, QString *result[], int &n);
  bool getSub(MyTree *t,QString *result[], int &n);
  void getXY(QString ID,int &x,int &y);
  bool countFeature(MyTree *t,int which, int &sum);
  bool Show(MyTree *p);
 };

#endif
